<template>
  <b-modal :ref="modalName" :id="modalName" size="md" hide-footer>
    <div class="list-filter-modal">
      <div class="d-flex list-filter-header mheader shadow">
        <h4 class="title col text-center color-black mb-0">Export Column</h4>
      </div>

      <div class="pt-1">
          <b-form class="filter-form">
            <b-row>
              <b-col cols="12">
                <b-form-group class="mb-2">
                  <label for="v-Status" class="d-block label-with-icon px-1">
                    <IconSearchLine /> Select Column</label>
                    <CustomSelectDropdown :options="moduleColumn" :selectAll="true" :isAllChecked="true"
                      :selectTitle="'Column'" :title="'Column'" :filterButton="false"
                      @filterButtonAction="exportAction"></CustomSelectDropdown>
                </b-form-group>
              </b-col>
            </b-row>
          </b-form>
      </div>
      <div class="text-center filter-footer">
        <b-button size="lg" class="theme-btn" variant="primary" @click="exportData">
          Export
        </b-button>
      </div>
    </div>
  </b-modal>
</template>

<script>
import {
  BForm,
  BButton,
  BCol,
  BRow,
  BImg,
  BFormInput,
  BFormCheckbox,
  BModal,
  BFormGroup,
} from "bootstrap-vue";
import store from "@/store";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import CustomSelectDropdown from "@/views/common/components/c-select-dropdown/CSelectDropdown.vue";

export default {
  components: {
    BForm,
    BButton,
    BCol,
    BRow,
    BImg,
    BModal,
    BFormInput,
    BFormCheckbox,
    BFormGroup,
    CustomSelectDropdown,
  },
  props: {
    modalName: {
      default: "columnModal",
    },
    exportUrl: {
      default: "export",
    },
    moduleColumn: {
      require: true,
    },
    module: {
      require: true,
    },
    checkedProducts: {
      require: true,
    },
    checkedAllBox: {
      require: true,
    },
    filter: {
      require: true,
    },
    searchQuery: {
      require: true,
    },
    sortBy: {
      require: true,
    },
    isSortDirDesc: {
      require: true,
    },
  },
  data() {
    return {
      selectedItemTitle: "",
      selectedColumn: [],
    };
  },
  methods: {
    exportAction(data) {
      if (data.selectedItems && data.selectedItems.length) {
        this.selectedColumn = data.selectedItems?.map((e) => e.id);  
      }
    },
    exportData() {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      let allFilter = {
        search: this.searchQuery,
        sortBy: this.sortBy,
        sortDesc: this.isSortDirDesc,
        column: this.selectedColumn,
        ids: this.checkedProducts,
        is_checkedAll: this.checkedAllBox,
        data: this.filter,
      };
      store
        .dispatch(this.module + "/" + this.exportUrl, allFilter)
        .then((response) => {
          if (response.data.status == true) {
            console.log(response.data)
            location.href = response.data.url;
            this.showToast(
              "success",
              "CheckCircleIcon",
              response.data.title,
              response.data.message
            );
            this.$refs[this.modalName].hide();
          } else {
            if (response.data.errors) {
              this.$refs.addEditFormRules.setErrors(response.data.errors);
            } else {
              this.showToast(
                "danger",
                "AlertCircleIcon",
                response.data.title,
                response.data.message
              );
            }
          }
          appLoading.style.display = "none";
        })
        .catch(() => {
          appLoading.style.display = "none";
        });
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title,
          icon,
          text: message,
          variant,
        },
      });
    },
  },
};
</script>
